## dukto 6.0.0+git20210713

=== CMakeLists.txt ===
project(dukto)
cmake_minimum_required(VERSION 3.1.0)

#FIXME: updater no longer works
#OPTION(USE_UPDATER "Add updater for application" OFF)
OPTION(USE_SINGLE_APP "Allow only one instance" OFF)
OPTION(USE_NOTIFY_LIBNOTIFY "Use libnotify for notifications (Linux only)" OFF)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

if(CMAKE_VERSION VERSION_LESS "3.7.0" AND CMAKE_SYSTEM_NAME STREQUAL "Android")
    set(ANDROID 1)
endif()

if(USE_UPDATER)
    add_definitions("-DUPDATER")
endif()
if(USE_SINGLE_APP AND NOT ANDROID)
    add_definitions("-DSINGLE_APP")
endif()
if(USE_NOTIFY_LIBNOTIFY AND UNIX AND NOT APPLE AND NOT ANDROID)
    find_package(PkgConfig REQUIRED)
    pkg_check_modules(LIBNOTIFY REQUIRED libnotify)
    add_definitions("-DNOTIFY_LIBNOTIFY")
    include_directories(${LIBNOTIFY_INCLUDE_DIRS})
    list(APPEND DUKTO_LIBS ${LIBNOTIFY_LIBRARIES})
endif()

if(NOT QT_DEFAULT_MAJOR_VERSION)
    find_package(Qt6 QUIET COMPONENTS Core)
    if (NOT Qt6_FOUND)
        find_package(Qt5 COMPONENTS Core REQUIRED)
        set(QT_DEFAULT_MAJOR_VERSION 5)
    else()
        set(QT_DEFAULT_MAJOR_VERSION 6)
    endif(NOT Qt6_FOUND)
endif(NOT QT_DEFAULT_MAJOR_VERSION)

set(QT_COMPONENTS Gui Network Qml QuickWidgets)
if(UNIX AND NOT APPLE AND NOT ANDROID)
    list(APPEND QT_COMPONENTS DBus)
endif()
set(QT_LIBRARIES "")
foreach(temp ${QT_COMPONENTS})
    list(APPEND QT_LIBRARIES "Qt${QT_DEFAULT_MAJOR_VERSION}::${temp}")
endforeach()

find_package(Qt${QT_DEFAULT_MAJOR_VERSION} COMPONENTS ${QT_COMPONENTS} REQUIRED)

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "Release")
endif()

if(CMAKE_BUILD_TYPE STREQUAL "Release")
    add_definitions("-DQT_NO_DEBUG_OUTPUT")
endif()

add_definitions("-DUNICODE")

set(DUKTO_HDR
    buddylistitemmodel.h
    destinationbuddy.h
    duktoprotocol.h
    duktowindow.h
    guibehind.h
    ipaddressitemmodel.h
    peer.h
    platform.h
    recentlistitemmodel.h
    settings.h
    systemtray.h
    theme.h
)

set(DUKTO_SRC
    buddylistitemmodel.cpp
    destinationbuddy.cpp
    duktoprotocol.cpp
    duktowindow.cpp
    guibehind.cpp
    ipaddressitemmodel.cpp
    main.cpp
    platform.cpp
    recentlistitemmodel.cpp
    settings.cpp
    systemtray.cpp
    theme.cpp
)

set(DUKTO_RESOURCES
    qml.qrc
    qml/common/common.qrc
)
if(Qt6_FOUND OR Qt5Core_VERSION VERSION_GREATER "5.14.0" OR Qt5Core_VERSION VERSION_EQUAL "5.14.0")
    list(APPEND DUKTO_RESOURCES "qml/new/main.qrc")
else()
    list(APPEND DUKTO_RESOURCES "qml/old/main.qrc")
endif()

if(USE_UPDATER)
    list(APPEND DUKTO_SRC updateschecker.cpp)
    list(APPEND DUKTO_HDR updateschecker.h)
endif()

if(WIN32)
    list(APPEND DUKTO_SRC ecwin7.cpp)
    list(APPEND DUKTO_HDR ecwin7.h)
    list(APPEND DUKTO_RESOURCES dukto.rc)
endif()

if(USE_SINGLE_APP AND NOT ANDROID)
    set(QAPPLICATION_CLASS "QApplication")
    add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/modules/SingleApplication)
    include_directories(${CMAKE_CURRENT_SOURCE_DIR}/modules/SingleApplication)
endif()

add_executable(${PROJECT_NAME}
                ${DUKTO_HDR}
                ${DUKTO_SRC}
                ${DUKTO_RESOURCES})

if(USE_SINGLE_APP AND NOT ANDROID)
    add_dependencies(${PROJECT_NAME} SingleApplication)
    link_directories(${CMAKE_CURRENT_BINARY_DIR}/modules/SingleApplication)
    target_link_libraries(${PROJECT_NAME} SingleApplication)
endif()

target_link_libraries(${PROJECT_NAME} ${DUKTO_LIBS} ${QT_LIBRARIES})

if(WIN32)
    set_target_properties(${PROJECT_NAME} PROPERTIES WIN32_EXECUTABLE True)
    target_link_libraries(${PROJECT_NAME} Ws2_32 ole32 user32)
endif(WIN32)

If (APPLE)
    SET( MACOSX_BUNDLE_ICON_FILE dukto.icns )
    SET_SOURCE_FILES_PROPERTIES( "dukto.icns" PROPERTIES MACOSX_PACKAGE_LOCATION Resources )
    target_sources(${PROJECT_NAME} PRIVATE ${MACOSX_BUNDLE_ICON_FILE})
    set_property(TARGET ${PROJECT_NAME} PROPERTY MACOSX_BUNDLE 1)
    find_library(CORE_SERVICES CoreServices REQUIRED)
    target_link_options(${PROJECT_NAME} PRIVATE "${CORE_SERVICES}/CoreServices.tbd")
endif()

if(UNIX AND NOT APPLE AND NOT ANDROID)
    install(TARGETS ${PROJECT_NAME}
            DESTINATION bin)
    install(FILES dukto.png
            DESTINATION share/pixmaps/)
    install(FILES dukto.desktop
            DESTINATION share/applications/)
endif()

=== modules/SingleApplication/examples/calculator/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7.0)

project(calculator LANGUAGES CXX)

set(CMAKE_AUTOMOC ON)

# SingleApplication base class
set(QAPPLICATION_CLASS QApplication)
add_subdirectory(../.. SingleApplication)

find_package(Qt${QT_DEFAULT_MAJOR_VERSION} COMPONENTS Core REQUIRED)

add_executable(${PROJECT_NAME}
    button.h
    calculator.h
    button.cpp
    calculator.cpp
    main.cpp
)

target_link_libraries(${PROJECT_NAME} SingleApplication::SingleApplication)

## dukto 6.0

=== debian/changelog ===
dukto (6.0-1mx17+1) mx; urgency=medium

  * Rebuild for MX 17.
  * Bump debhelper compat to 9.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 02 Dec 2017 17:30:53 -0800

dukto (6.0-1mx150+1) mx; urgency=medium

  * Repackaged for MX 15.

 -- Mike Purtell <mandbx@sbcglobal.net>  Sat, 25 Jul 2015 20:22:34 -0700

dukto (6.0-1mcr120+1) mepis; urgency=low

  * New release, rebuild for MEPIS 12.0.
  * debian/rules: compress deb packages with xz.
  * Add missing debian/copyright file.
  * Trim down build-depends to what actually is needed.
  * Switch to 3.0 (quilt) source format.
  * Add debian/install file and modify rules file to install binary into /usr/bin.
  * Patch dukto.desktop so it appears under Utilities in the menu.

 -- Steven Pusser (Stevo) <maintainer@mepiscommunity.org>  Sun, 11 Jan 2015 18:43:51 -0800

dukto (5.0-2~3~precise1) precise; urgency=low

  * Auto build.

 -- Launchpad Package Builder <noreply@launchpad.net>  Fri, 28 Jun 2013 20:33:26 +0000

dukto (5.0) stable; urgency=low

  * Initial Release (Beta)

 -- Emanuele Colombo <dukto@msec.it>  Mon, 24 Oct 2011 21:50:38 +0200

=== debian/control ===
Source: dukto
Section: net
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
Bugs: mailto: <stevep@mxlinux.org>
XSBC-Original-Maintainer: Mike Purtell (mmikeinsantarosa) <maintainer@mepiscommunity.org>
Build-Depends: debhelper (>= 9), libqt4-dev (>= 4.7.2)
Homepage: http://www.msec.it/dukto/

Package: dukto
Architecture: any
Depends: ${shlibs:Depends}
Description: Easy multi-platform file and text transfer tool
 Dukto is an easy file transfer tool designed for LAN use.
 You can use it to transfer files from one PC to another,
 without worrying about users, permissions, operating systems,
 protocols, clients, servers and so on... Just start Dukto on
 the two PCs and transfer files and folders by dragging onto
 its window.

=== debian/rules ===
#!/usr/bin/make -f

export QT_SELECT=qt4

%:
	dh $@ --parallel

override_dh_auto_install:

## dukto 6.0.0%2Bgit20210713

=== debian/changelog ===
dukto (6.0.0+git20210713-1~mx23+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Sun, 20 Aug 2023 20:00:11 -0700

dukto (6.0.0+git20210713-1~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 14 Jul 2021 15:00:36 -0700

dukto (6.0.0+git20210713-1~18.04~ppa1) bionic; urgency=medium

  * New upstream snapshot

 -- Xu Zhen <xuzhen@fastmail.com>  Tue, 13 Jul 2021 19:23:24 +0800

dukto (6.0.0+git20210707-1~18.04~ppa1) bionic; urgency=medium

  * New upstream snapshot
  * Remove runtime dependency qml-module-qtquick-controls2

 -- Xu Zhen <xuzhen@fastmail.com>  Wed, 07 Jul 2021 20:12:24 +0800

dukto (6.0.0+git20210701-1~18.04~ppa2) bionic; urgency=medium

  * Fix missing runtime dependency qml-module-qtquick-controls2

 -- Xu Zhen <xuzhen@fastmail.com>  Fri, 02 Jul 2021 19:14:54 +0800

dukto (6.0.0+git20210701-1~18.04~ppa1) bionic; urgency=medium

  * New upstream snapshot

 -- Xu Zhen <xuzhen@fastmail.com>  Thu, 01 Jul 2021 20:18:56 +0800

dukto (6.0.0+git20210628-1~18.04~ppa1) bionic; urgency=medium

  * Change upstream to https://github.com/xuzhen/dukto-qt5
    - Support lower version of Qt 5
    - Use CMake for building

 -- Xu Zhen <xuzhen@fastmail.com>  Tue, 29 Jun 2021 19:18:39 +0800

dukto (6.0.0-1~18.04~ppa2) bionic; urgency=medium

  * Fixed desktop file

 -- Xu Zhen <xuzhen@fastmail.com>  Sun, 20 Jun 2021 21:16:29 +0800

dukto (6.0.0-1~18.04~ppa1) bionic; urgency=medium

  * Initial Release

 -- Xu Zhen <xuzhen@fastmail.com>  Sun, 20 Jun 2021 20:53:29 +0800

=== debian/control ===
Source: dukto
Section: net
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Xu Zhen <xuzhen@fastmail.com>
Standards-Version: 4.4.0
Homepage: https://github.com/xuzhen/dukto-qt5
Build-Depends: cmake (>= 3.1.0),
               debhelper (>= 11),
               libnotify-dev,
               qtbase5-dev (>= 5.3.0),
               qtdeclarative5-dev

Package: dukto
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: easy file transfer tool for LAN
 Dukto is an easy file transfer tool designed for LAN use. Transfer
 files from one PC (or other device) to another, without worrying
 about users, permissions, operating systems, protocols, clients,
 servers and so on… Just start Dukto on the two PCs and transfer
 files and folders by dragging onto its window. That's all.
 .
 This is a fork of Dukto that can use Qt5.

=== debian/rules ===
#!/usr/bin/make -f

export QT_SELECT = 5
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DUSE_SINGLE_APP=ON -DUSE_NOTIFY_LIBNOTIFY=ON

override_dh_strip:
	dh_strip --no-automatic-dbgsym

## dukto 6.0.0+git20210713

=== debian/control ===
--- 
+++ 
@@ -19,6 +19,6 @@
  files from one PC (or other device) to another, without worrying
  about users, permissions, operating systems, protocols, clients,
  servers and so on… Just start Dukto on the two PCs and transfer
- files and folders by dragging onto its window. That's all.
+ files and folders by dragging onto it's window. That's all.
  .
  This is a fork of Dukto that can use Qt5.

## dukto 6.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
+cmake_minimum_required(VERSION 3.7.0 FATAL_ERROR)
 project(dukto)
-cmake_minimum_required(VERSION 3.1.0)
 
 #FIXME: updater no longer works
 #OPTION(USE_UPDATER "Add updater for application" OFF)
@@ -11,10 +11,6 @@
 
 set(CMAKE_AUTOMOC ON)
 set(CMAKE_AUTORCC ON)
-
-if(CMAKE_VERSION VERSION_LESS "3.7.0" AND CMAKE_SYSTEM_NAME STREQUAL "Android")
-    set(ANDROID 1)
-endif()
 
 if(USE_UPDATER)
     add_definitions("-DUPDATER")
@@ -30,26 +26,49 @@
     list(APPEND DUKTO_LIBS ${LIBNOTIFY_LIBRARIES})
 endif()
 
-if(NOT QT_DEFAULT_MAJOR_VERSION)
+if(ANDROID)
+    set(ANDROID_ABI ${CMAKE_ANDROID_ARCH_ABI})
+endif()
+
+if(QT_CMAKE_ROOT)
+    get_filename_component(QT_CMAKE_ROOT "${QT_CMAKE_ROOT}" ABSOLUTE)
+    if(NOT IS_DIRECTORY "${QT_CMAKE_ROOT}")
+        message(FATAL_ERROR "The directory specified by QT_CMAKE_ROOT was not found")
+    endif()
+    if(IS_DIRECTORY "${QT_CMAKE_ROOT}/Qt6")
+        set(QT_MAJOR_VERSION 6)
+    elseif(IS_DIRECTORY "${QT_CMAKE_ROOT}/Qt5")
+        set(QT_MAJOR_VERSION 5)
+    else()
+        message(FATAL_ERROR "Found neither Qt5 nor Qt6 directory in ${QT_CMAKE_ROOT}")
+    endif()
+elseif(NOT QT_MAJOR_VERSION)
     find_package(Qt6 QUIET COMPONENTS Core)
     if (NOT Qt6_FOUND)
         find_package(Qt5 COMPONENTS Core REQUIRED)
-        set(QT_DEFAULT_MAJOR_VERSION 5)
+        set(QT_MAJOR_VERSION 5)
     else()
-        set(QT_DEFAULT_MAJOR_VERSION 6)
-    endif(NOT Qt6_FOUND)
-endif(NOT QT_DEFAULT_MAJOR_VERSION)
-
-set(QT_COMPONENTS Gui Network Qml QuickWidgets)
+        set(QT_MAJOR_VERSION 6)
+    endif()
+endif(QT_CMAKE_ROOT)
+
+set(QT_COMPONENTS Core Gui Network Qml QuickWidgets)
 if(UNIX AND NOT APPLE AND NOT ANDROID)
     list(APPEND QT_COMPONENTS DBus)
 endif()
-set(QT_LIBRARIES "")
-foreach(temp ${QT_COMPONENTS})
-    list(APPEND QT_LIBRARIES "Qt${QT_DEFAULT_MAJOR_VERSION}::${temp}")
-endforeach()
-
-find_package(Qt${QT_DEFAULT_MAJOR_VERSION} COMPONENTS ${QT_COMPONENTS} REQUIRED)
+if(ANDROID AND QT_MAJOR_VERSION EQUAL 5)
+    list(APPEND QT_COMPONENTS AndroidExtras)
+endif()
+
+if(QT_CMAKE_ROOT)
+    set(QT_COMPONENTS_EXTRA Quick QmlModels Widgets)
+    set(Qt${QT_MAJOR_VERSION}_DIR "${QT_CMAKE_ROOT}/Qt${QT_MAJOR_VERSION}")
+    foreach(temp ${QT_COMPONENTS} ${QT_COMPONENTS_EXTRA})
+        set(Qt${QT_MAJOR_VERSION}${temp}_DIR "${QT_CMAKE_ROOT}/Qt${QT_MAJOR_VERSION}${temp}")
+    endforeach()
+endif()
+
+find_package(Qt${QT_MAJOR_VERSION} COMPONENTS ${QT_COMPONENTS} REQUIRED)
 
 if(NOT CMAKE_BUILD_TYPE)
     set(CMAKE_BUILD_TYPE "Release")
@@ -60,6 +79,8 @@
 endif()
 
 add_definitions("-DUNICODE")
+
+include_directories(${CMAKE_CURRENT_SOURCE_DIR})
 
 set(DUKTO_HDR
     buddylistitemmodel.h
@@ -68,6 +89,12 @@
     duktowindow.h
     guibehind.h
     ipaddressitemmodel.h
+    miniwebserver.h
+    network/buddymessage.h
+    network/filedata.h
+    network/messenger.h
+    network/receiver.h
+    network/sender.h
     peer.h
     platform.h
     recentlistitemmodel.h
@@ -84,6 +111,12 @@
     guibehind.cpp
     ipaddressitemmodel.cpp
     main.cpp
+    miniwebserver.cpp
+    network/buddymessage.cpp
+    network/filedata.cpp
+    network/messenger.cpp
+    network/receiver.cpp
+    network/sender.cpp
     platform.cpp
     recentlistitemmodel.cpp
     settings.cpp
@@ -95,7 +128,7 @@
     qml.qrc
     qml/common/common.qrc
 )
-if(Qt6_FOUND OR Qt5Core_VERSION VERSION_GREATER "5.14.0" OR Qt5Core_VERSION VERSION_EQUAL "5.14.0")
+if(Qt6_FOUND OR Qt5Core_VERSION VERSION_GREATER_EQUAL "5.14.0")
     list(APPEND DUKTO_RESOURCES "qml/new/main.qrc")
 else()
     list(APPEND DUKTO_RESOURCES "qml/old/main.qrc")
@@ -112,29 +145,57 @@
     list(APPEND DUKTO_RESOURCES dukto.rc)
 endif()
 
+if(ANDROID)
+    list(APPEND DUKTO_SRC androidutils.cpp)
+    list(APPEND DUKTO_HDR androidutils.h)
+endif()
+
 if(USE_SINGLE_APP AND NOT ANDROID)
     set(QAPPLICATION_CLASS "QApplication")
     add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/modules/SingleApplication)
     include_directories(${CMAKE_CURRENT_SOURCE_DIR}/modules/SingleApplication)
 endif()
 
-add_executable(${PROJECT_NAME}
-                ${DUKTO_HDR}
-                ${DUKTO_SRC}
-                ${DUKTO_RESOURCES})
+if(ANDROID)
+    #  Qt6:
+    #    /path/to/qt6/bin/qt-cmake -DANDROID_NDK_ROOT=/path/to/ndk -DANDROID_SDK_ROOT=/path/to/sdk srcdir
+    #  Qt5:
+    #    export ANDROID_NDK_ROOT=/path/to/ndk ANDROID_SDK_ROOT=/path/to/sdk
+    #    cmake -DCMAKE_SYSTEM_NAME=Android -DCMAKE_ANDROID_ARCH_ABI=arm64-v8a -DQT_CMAKE_ROOT=/path/to/qt/cmake srcdir
+    if(QT_MAJOR_VERSION GREATER 5)
+        qt_add_executable(${PROJECT_NAME}
+                          ${DUKTO_HDR}
+                          ${DUKTO_SRC}
+                          ${DUKTO_RESOURCES})
+    else()
+        add_library(${PROJECT_NAME} SHARED
+                    ${DUKTO_HDR}
+                    ${DUKTO_SRC}
+                    ${DUKTO_RESOURCES})
+    endif()
+else()
+    add_executable(${PROJECT_NAME}
+                   ${DUKTO_HDR}
+                   ${DUKTO_SRC}
+                   ${DUKTO_RESOURCES})
+endif(ANDROID)
 
 if(USE_SINGLE_APP AND NOT ANDROID)
     add_dependencies(${PROJECT_NAME} SingleApplication)
     link_directories(${CMAKE_CURRENT_BINARY_DIR}/modules/SingleApplication)
-    target_link_libraries(${PROJECT_NAME} SingleApplication)
-endif()
-
-target_link_libraries(${PROJECT_NAME} ${DUKTO_LIBS} ${QT_LIBRARIES})
+    target_link_libraries(${PROJECT_NAME} PRIVATE SingleApplication)
+endif()
+
+set(QT_LIBRARIES "")
+foreach(temp ${QT_COMPONENTS})
+    list(APPEND QT_LIBRARIES "Qt${QT_MAJOR_VERSION}::${temp}")
+endforeach()
+target_link_libraries(${PROJECT_NAME} PRIVATE ${DUKTO_LIBS} ${QT_LIBRARIES})
 
 if(WIN32)
     set_target_properties(${PROJECT_NAME} PROPERTIES WIN32_EXECUTABLE True)
-    target_link_libraries(${PROJECT_NAME} Ws2_32 ole32 user32)
-endif(WIN32)
+    target_link_libraries(${PROJECT_NAME} PRIVATE Ws2_32 ole32 user32)
+endif()
 
 If (APPLE)
     SET( MACOSX_BUNDLE_ICON_FILE dukto.icns )
@@ -145,6 +206,115 @@
     target_link_options(${PROJECT_NAME} PRIVATE "${CORE_SERVICES}/CoreServices.tbd")
 endif()
 
+if(ANDROID)
+    if(QT_MAJOR_VERSION EQUAL 5)
+        # find the Android SDK
+        set(ANDROID_SDK_ROOT $ENV{ANDROID_SDK_ROOT})
+        if(NOT ANDROID_SDK_ROOT)
+            message(FATAL_ERROR "You need to set the ANDROID_SDK_ROOT environment variable to your Android SDK directory")
+        endif()
+        message(STATUS "Android SDK: ${ANDROID_SDK_ROOT}")
+    
+        # find the Android NDK
+        set(ANDROID_NDK_ROOT $ENV{ANDROID_NDK_ROOT})
+        if(NOT ANDROID_NDK_ROOT)
+            message(FATAL_ERROR "You need to set the ANDROID_NDK_ROOT environment variable to your Android NDK directory")
+        endif()
+        message(STATUS "Android NDK: ${ANDROID_NDK_ROOT}")
+    
+        get_filename_component(QT_BINARY_ROOT "${Qt5Core_DIR}/../../../bin" ABSOLUTE)
+    
+        add_custom_target("${PROJECT_NAME}_apkdir"
+            COMMAND ${CMAKE_COMMAND} -E remove_directory "${CMAKE_CURRENT_BINARY_DIR}/apk"
+            COMMAND ${CMAKE_COMMAND} -E make_directory "${CMAKE_CURRENT_BINARY_DIR}/apk"
+            DEPENDS "${PROJECT_NAME}"
+            COMMENT "Preparing APK directory"
+        )
+        add_custom_target("${PROJECT_NAME}_apkconf"
+            COMMAND "${QT_BINARY_ROOT}/qmake"
+                "${CMAKE_CURRENT_SOURCE_DIR}/dukto.pro"
+                "-spec" "android-clang"
+                "CONFIG+=qtquickcompiler"
+                "ANDROID_ABIS=${ANDROID_ABI}"
+            DEPENDS "${PROJECT_NAME}_apkdir"
+            WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/apk"
+            COMMENT "Generating APK configuration"
+        )
+        add_custom_target(apk ALL
+            COMMAND ${CMAKE_COMMAND} -E remove_directory "${CMAKE_CURRENT_BINARY_DIR}/apk/libs/${ANDROID_ABI}"
+            COMMAND ${CMAKE_COMMAND} -E make_directory "${CMAKE_CURRENT_BINARY_DIR}/apk/libs/${ANDROID_ABI}"
+            COMMAND ${CMAKE_COMMAND} -E copy "${CMAKE_CURRENT_BINARY_DIR}/libdukto.so" "${CMAKE_CURRENT_BINARY_DIR}/apk/libs/${ANDROID_ABI}/libDukto_${ANDROID_ABI}.so"
+            COMMAND "${QT_BINARY_ROOT}/androiddeployqt"
+                --output "${CMAKE_CURRENT_BINARY_DIR}/apk"
+                --input android-Dukto-deployment-settings.json
+                --gradle
+            DEPENDS "${PROJECT_NAME}_apkconf"
+            WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/apk"
+            COMMENT "Generating APK"
+        )
+    elseif(QT_MAJOR_VERSION EQUAL 6)
+        if(Qt6Core_VERSION VERSION_GREATER_EQUAL "6.6.0")
+            qt6_policy(SET QTP0002 NEW)
+        endif()
+        # get version
+        file(READ "${CMAKE_CURRENT_SOURCE_DIR}/version.h" ver)
+        string(REGEX MATCH "#define VERSION_MAJOR ([0-9]+)" _ ${ver})
+        set(ver_major ${CMAKE_MATCH_1})
+        string(REGEX MATCH "#define VERSION_MINOR ([0-9]+)" _ ${ver})
+        set(ver_minor ${CMAKE_MATCH_1})
+        string(REGEX MATCH "#define VERSION_PATCH ([0-9]+)" _ ${ver})
+        set(ver_patch ${CMAKE_MATCH_1})
+        # get target abis
+        if(QT_ANDROID_BUILD_ALL_ABIS)
+            set(target_abis ${QT_DEFAULT_ANDROID_ABIS})
+        else()
+            set(target_abis ${QT_ANDROID_ABIS})
+        endif()
+        # calculate abi code
+        set(abi_code 0)
+        foreach(abi IN ITEMS ${target_abis})
+            if(abi STREQUAL "armeabi-v7a")
+                math(EXPR abi_code "${abi_code} | 1")
+            elseif(abi STREQUAL "arm64-v8a")
+                math(EXPR abi_code "${abi_code} | 2")
+            elseif(abi STREQUAL "x86_64")
+                math(EXPR abi_code "${abi_code} | 4")
+            elseif(abi STREQUAL "x86")
+                math(EXPR abi_code "${abi_code} | 8")
+            else()
+                message(FATAL_ERROR "Unknown ABI: ${abi}")
+            endif()
+        endforeach()
+        # calculate version code
+        set(ver_code "${ver_major}")
+        string(LENGTH "${ver_minor}" len)
+        if(len EQUAL 1)
+            set(ver_code "${ver_code}0${ver_minor}")
+        else()
+            set(ver_code "${ver_code}${ver_minor}")
+        endif()
+        string(LENGTH "${ver_patch}" len)
+        if(len EQUAL 1)
+            set(ver_code "${ver_code}0${ver_patch}")
+        else()
+            set(ver_code "${ver_code}${ver_patch}")
+        endif()
+        string(LENGTH "${abi_code}" len)
+        if(len EQUAL 1)
+            set(ver_code "${ver_code}260${abi_code}")
+        else()
+            set(ver_code "${ver_code}26${abi_code}")
+        endif()
+    
+        set_target_properties(dukto PROPERTIES
+            QT_ANDROID_MIN_SDK_VERSION 26
+            QT_ANDROID_VERSION_NAME "${ver_major}.${ver_minor}.${ver_patch}"
+            QT_ANDROID_VERSION_CODE "${ver_code}"
+            QT_ANDROID_PACKAGE_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/android/qt6"
+        )
+    endif()
+endif(ANDROID)
+
 if(UNIX AND NOT APPLE AND NOT ANDROID)
     install(TARGETS ${PROJECT_NAME}
             DESTINATION bin)

=== debian/changelog ===
dukto (6.2.0-1~mx25+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 21 Jun 2025 14:00:42 -0700

dukto (6.2.0-1~22.04~ppa1) jammy; urgency=medium

  * New release

 -- Xu Zhen <xuzhen@fastmail.com>  Sat, 20 Apr 2024 00:17:11 +0800

dukto (6.1.1-1~23.10~ppa1) mantic; urgency=medium

  * New release

 -- Xu Zhen <xuzhen@fastmail.com>  Mon, 16 Oct 2023 20:25:57 +0800

dukto (6.1.0+git20231014-1~23.10~ppa1) mantic; urgency=medium

  * New release

 -- Xu Zhen <xuzhen@fastmail.com>  Sat, 14 Oct 2023 00:12:01 +0800

dukto (6.0.0+git20220321-1~23.04~ppa1) lunar; urgency=medium

  * New upstream snapshot

 -- Xu Zhen <xuzhen@fastmail.com>  Mon, 21 Mar 2022 18:59:38 +0800

dukto (6.0.0+git20220316-1~22.04~ppa1) jammy; urgency=medium

  * New upstream snapshot

 -- Xu Zhen <xuzhen@fastmail.com>  Wed, 16 Mar 2022 18:49:50 +0800

dukto (6.0.0+git20210919-1~21.10~ppa1) impish; urgency=medium

  * New upstream snapshot

 -- Xu Zhen <xuzhen@fastmail.com>  Sun, 19 Sep 2021 20:10:37 +0800

dukto (6.0.0+git20210902-1~21.10~ppa1) impish; urgency=medium

  * New upstream snapshot

 -- Xu Zhen <xuzhen@fastmail.com>  Sat, 04 Sep 2021 13:01:29 +0800

dukto (6.0.0+git20210717-1~21.10~ppa1) impish; urgency=medium

  * New upstream snapshot

 -- Xu Zhen <xuzhen@fastmail.com>  Sun, 18 Jul 2021 10:18:43 +0800

dukto (6.0.0+git20210716-1~21.10~ppa1) impish; urgency=medium

  * New upstream snapshot

 -- Xu Zhen <xuzhen@fastmail.com>  Fri, 16 Jul 2021 21:21:38 +0800

dukto (6.0.0+git20210713-1~21.10~ppa1) impish; urgency=medium

  * New upstream snapshot

 -- Xu Zhen <xuzhen@fastmail.com>  Tue, 13 Jul 2021 19:23:24 +0800

dukto (6.0.0+git20210707-1~21.10~ppa1) impish; urgency=medium

  * New upstream snapshot
  * Remove runtime dependency qml-module-qtquick-controls2

 -- Xu Zhen <xuzhen@fastmail.com>  Wed, 07 Jul 2021 20:12:24 +0800

dukto (6.0.0+git20210701-1~21.10~ppa2) impish; urgency=medium

  * Fix missing runtime dependency qml-module-qtquick-controls2

 -- Xu Zhen <xuzhen@fastmail.com>  Fri, 02 Jul 2021 19:14:54 +0800

dukto (6.0.0+git20210701-1~21.10~ppa1) impish; urgency=medium

  * New upstream snapshot

 -- Xu Zhen <xuzhen@fastmail.com>  Thu, 01 Jul 2021 20:18:56 +0800

dukto (6.0.0+git20210628-1~21.10~ppa1) impish; urgency=medium

  * Change upstream to https://github.com/xuzhen/dukto-qt5
    - Support lower version of Qt 5
    - Use CMake for building

 -- Xu Zhen <xuzhen@fastmail.com>  Tue, 29 Jun 2021 19:18:39 +0800

dukto (6.0.0-1~21.10~ppa2) impish; urgency=medium

  * Fixed desktop file

 -- Xu Zhen <xuzhen@fastmail.com>  Sun, 20 Jun 2021 21:16:29 +0800

dukto (6.0.0-1~21.10~ppa1) impish; urgency=medium

  * Initial Release

 -- Xu Zhen <xuzhen@fastmail.com>  Sun, 20 Jun 2021 20:53:29 +0800

=== debian/control ===
Source: dukto
Section: net
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Xu Zhen <xuzhen@fastmail.com>
Standards-Version: 4.4.0
Homepage: https://github.com/xuzhen/dukto-qt5
Build-Depends: cmake (>= 3.7.0),
               debhelper (>= 11),
               libgl-dev,
               libnotify-dev,
               libqt6opengl6-dev | qt6-base-dev | qtbase5-dev (>= 5.3.0),
               libssl-dev,
               libvulkan-dev,
               libxkbcommon-dev,
               lsb-release,
               qt6-declarative-dev | qtdeclarative5-dev (>= 5.3.0)

Package: dukto
Architecture: any
Depends: ${dist:Depends}, ${misc:Depends}, ${shlibs:Depends}
Recommends: ${dist:Recommends}
Description: easy file transfer tool for LAN
 Dukto is an easy file transfer tool designed for LAN use. Transfer
 files from one PC (or other device) to another, without worrying
 about users, permissions, operating systems, protocols, clients,
 servers and so on… Just start Dukto on the two PCs and transfer
 files and folders by dragging onto it's window. That's all.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DISTVER := $(shell lsb_release -rs 2>/dev/null)

cmpver = $(shell dpkg --compare-versions '$(1)' '$(2)' '$(3)' && echo yes || echo no)

ifeq (yes, $(call cmpver,$(DISTVER),lt,22.04))
	SUBSTVARS = -Vdist:Depends="qml-module-qtquick2"
else ifeq ($(DISTVER), 22.04)
	SUBSTVARS = -Vdist:Depends="qml6-module-qtquick, qml6-module-qtqml-workerscript, qt6-qpa-plugins" -Vdist:Recommends="qt6-wayland"
else
	SUBSTVARS = -Vdist:Depends="qml6-module-qtquick, qml6-module-qtqml-workerscript" -Vdist:Recommends="qt6-wayland"
endif

%:
	dh $@

override_dh_gencontrol:
	dh_gencontrol -- $(SUBSTVARS)

override_dh_auto_configure:
	#dh_auto_configure -- dukto.pro
	dh_auto_configure -- -DUSE_SINGLE_APP=ON -DUSE_NOTIFY_LIBNOTIFY=ON
